Index: i370.h
===================================================================
RCS file: /home/linas/cvsroot/binutils/include/opcode/i370.h,v
retrieving revision 1.16
diff --unified=6 -r1.16 i370.h
--- i370.h	1999/07/19 20:48:35	1.16
+++ i370.h	1999/09/03 22:43:48
@@ -1,10 +1,10 @@
 /* i370.h -- Header file for S/390 opcode table
-   Copyright 1994, 1995 Free Software Foundation, Inc.
-   Written by Ian Lance Taylor, Cygnus Support
-   Hacked from the powerpc tables
+   Copyright 1994, 1995, 1998, 1999 Free Software Foundation, Inc.
+   PowerPC version written by Ian Lance Taylor, Cygnus Support
+   Rewritten for i370 ESA/390 support, Linas Vepstas <linas@linas.org>
 
 This file is part of GDB, GAS, and the GNU binutils.
 
 GDB, GAS, and the GNU binutils are free software; you can redistribute
 them and/or modify them under the terms of the GNU General Public
 License as published by the Free Software Foundation; either version
@@ -184,84 +184,61 @@
 
    /* name -- handy for debugging, otherwise pointless */
    char * name; 
 };
 
 /* Elements in the table are retrieved by indexing with values from
-   the operands field of the powerpc_opcodes table.  */
+   the operands field of the i370_opcodes table.  */
 
 extern const struct i370_operand i370_operands[];
 
-/* Values defined for the flags field of a struct powerpc_operand.  */
-
-/* This operand takes signed values.  */
-#define I370_OPERAND_SIGNED (0x01)
+/* Values defined for the flags field of a struct i370_operand.  */
 
 /* This operand should be wrapped in parentheses rather than
- *  separated from the previous by a comma.  This is used for RS form
- *  instructions which want their operands to look like
- *      reg,displacement(basereg)
- */
+   separated from the previous by a comma.  This is used for S, RS and
+   SS form instructions which want their operands to look like
+        reg,displacement(basereg) */
+#define I370_OPERAND_SBASE (0x01)
+
+/* This operand is a base register.  It may or may not appear next
+   to an index register, i.e. either of the two forms
+        reg,displacement(basereg)
+        reg,displacement(index,basereg) */
 #define I370_OPERAND_BASE (0x02)
 
 /* This pair of operands should be wrapped in parentheses rather than
- *  separated from the last by a comma.  This is used for the RX form
- *  instructions which want their operands to look like
- *      reg,displacement(index,basereg)
- */
+    separated from the last by a comma.  This is used for the RX form
+    instructions which want their operands to look like
+        reg,displacement(index,basereg) */
 #define I370_OPERAND_INDEX (0x04)
 
-// /* This operand may use the symbolic names for the CR fields, which
-//    are
-//        lt  0	gt  1	eq  2	so  3	un  3
-//    These may be combined arithmetically, as in cr2*4+gt.  These are
-//    only supported on the PowerPC, not the POWER.  */
-// #define PPC_OPERAND_CR (020)
-// 
 /* This operand names a register.  The disassembler uses this to print
    register names with a leading 'r'.  */
-#define I370_OPERAND_GPR (0x40)
+#define I370_OPERAND_GPR (0x08)
 
 /* This operand names a floating point register.  The disassembler
    prints these with a leading 'f'.  */
-#define I370_OPERAND_FPR (0x100)
+#define I370_OPERAND_FPR (0x10)
+
+/* This operand is a displacement.  */
+#define I370_OPERAND_RELATIVE (0x20)
 
-/* This operand is a relative branch displacement.  The disassembler
-   prints these symbolically if possible.  */
-#define I370_OPERAND_RELATIVE (0x200)
-
-/* This operand is an absolute branch address.  The disassembler
-   prints these symbolically if possible.  */
-#define I370_OPERAND_ABSOLUTE (0x400)
+/* This operand is a length, such as that in SS form instructions.  */
+#define I370_OPERAND_LENGTH (0x40)
 
 /* This operand is optional, and is zero if omitted.  This is used for
    the optional B2 field in the shift-left, shift-right instructions.  The
    assembler must count the number of operands remaining on the line,
    and the number of operands remaining for the opcode, and decide
    whether this operand is present or not.  The disassembler should
    print this operand out only if it is not zero.  */
-#define I370_OPERAND_OPTIONAL (0x800)
+#define I370_OPERAND_OPTIONAL (0x80)
 
-// /* This flag is only used with PPC_OPERAND_OPTIONAL.  If this operand
-//    is omitted, then for the next operand use this operand value plus
-//    1, ignoring the next operand field for the opcode.  This wretched
-//    hack is needed because the Power rotate instructions can take
-//    either 4 or 5 operands.  The disassembler should print this operand
-//    out regardless of the PPC_OPERAND_OPTIONAL field.  */
-// #define PPC_OPERAND_NEXT (02000)
-// 
-// /* This operand should be regarded as a negative number for the
-//    purposes of overflow checking (i.e., the normal most negative
-//    number is disallowed and one more than the normal most positive
-//    number is allowed).  This flag will only be set for a signed
-//    operand.  */
-// #define PPC_OPERAND_NEGATIVE (04000)
 
-/* Define some misc macros.  We keep them
-   with the operands table for simplicity.  The macro table is an
-   array of struct powerpc_macro.  */
+/* Define some misc macros.  We keep them with the operands table 
+   for simplicity.  The macro table is an array of struct i370_macro.  */
 
 struct i370_macro
 {
   /* The macro name.  */
   const char *name;
 
