Index: i370-dis.c
===================================================================
RCS file: /home/linas/cvsroot/binutils/opcodes/i370-dis.c,v
retrieving revision 1.9
diff --unified=6 -r1.9 i370-dis.c
--- i370-dis.c	1999/05/28 21:57:10	1.9
+++ i370-dis.c	1999/09/03 22:55:05
@@ -1,11 +1,11 @@
 
-/* i370-dis.c -- Disassemble I370 instructions
+/* i370-dis.c -- Disassemble Instruction 370 (ESA/390) instructions
    Copyright 1994 Free Software Foundation, Inc.
-   Written by Ian Lance Taylor, Cygnus Support
-   Hacked by Linas Vepstas <linas@linas.org>,  needs more work still
+   PowerPC version written by Ian Lance Taylor, Cygnus Support
+   Rewritten for i370 ESA/390 support by Linas Vepstas <linas@linas.org> 
 
 This file is part of GDB, GAS, and the GNU binutils.
 
 GDB, GAS, and the GNU binutils are free software; you can redistribute
 them and/or modify them under the terms of the GNU General Public
 License as published by the Free Software Foundation; either version
@@ -32,34 +32,27 @@
 
 int
 print_insn_i370 (memaddr, info)
      bfd_vma memaddr;
      struct disassemble_info *info;
 {
-  bfd_byte buffer[6];
+  bfd_byte buffer[8];
   int status;
   i370_insn_t insn;
   const struct i370_opcode *opcode;
   const struct i370_opcode *opcode_end;
-  unsigned int op, iop;
 
-  // printf ("Sorry duude not implemented see opcodes/i370-dis.c for more\n");
-  // (*info->fprintf_func) (info->stream, "like whoa wowow\n" );
-
-  status = (*info->read_memory_func) (memaddr, buffer, 4, info);
-/*
+  status = (*info->read_memory_func) (memaddr, buffer, 6, info);
   if (status != 0)
     {
       (*info->memory_error_func) (status, memaddr, info);
       return -1;
     }
-*/
-  // insn = bfd_getb32 (buffer);
 
-  /* Get the major opcode of the instruction.  */
-  iop = buffer[0];
+  /* Cast the bytes into the insn */
+  insn = *((i370_insn_t *) buffer);
 
   /* Find the first match in the opcode table.  We could speed this up
      a bit by doing a binary search on the major opcode.  */
   opcode_end = i370_opcodes + i370_num_opcodes;
   for (opcode = i370_opcodes; opcode < opcode_end; opcode++)
     {
@@ -67,20 +60,16 @@
       const unsigned char *opindex;
       const struct i370_operand *operand;
       int invalid;
       int need_comma;
       int need_paren;
 
-      /* if ((insn & opcode->mask) != opcode->opcode
-       *    || (opcode->flags & dialect) == 0)
-       * continue;
-       */
+      if ((insn & opcode->mask) != opcode->opcode)
+      /*   || (opcode->flags & dialect) == 0) */
+        continue;
       
-      op = opcode->opcode.b[0];
-
-      if (op != iop) continue;
 
       /* Make two passes over the operands.  First see if any of them
          have extraction functions, and, if they do, make sure the
          instruction is valid.  */
       invalid = 0;
       for (opindex = opcode->operands; *opindex != 0; opindex++)
@@ -108,173 +97,59 @@
           /* Extract the value from the instruction.  */
           if (operand->extract)
             value = (*operand->extract) (insn, (int *) NULL);
           else
             {
               value = (insn.i[0] >> operand->shift) & ((1 << operand->bits) - 1);
-              if ((operand->flags & I370_OPERAND_SIGNED) != 0
-                  && (value & (1 << (operand->bits - 1))) != 0)
-                value -= 1 << operand->bits;
             }
 
           /* Print the operand as directed by the flags.  */
-          if ((operand->flags & I370_OPERAND_GPR) != 0)
-            (*info->fprintf_func) (info->stream, "r%ld, ", value);
-          else
-            (*info->fprintf_func) (info->stream, "%ld, ", value);
-
-        }
-
-      return opcode->len;
-
-    }
-
-
-  /* We could not find a match.  */
-  // (*info->fprintf_func) (info->stream, ".long 0x%lx", insn);
-  (*info->fprintf_func) (info->stream, "duuude unknown insn: %x %x ", buffer[0], buffer[1]);
-
-  return 2;
-}
-
-#ifdef JUNK
-xxxxxxxxxxxxxxxxxxxxxxxxxxxx
-
-  /* Find the first match in the opcode table.  We could speed this up
-     a bit by doing a binary search on the major opcode.  */
-  opcode_end = powerpc_opcodes + powerpc_num_opcodes;
-  for (opcode = powerpc_opcodes; opcode < opcode_end; opcode++)
-    {
-      unsigned long table_op;
-      const unsigned char *opindex;
-      const struct powerpc_operand *operand;
-      int invalid;
-      int need_comma;
-      int need_paren;
-
-      table_op = PPC_OP (opcode->opcode);
-      if (op < table_op)
-        break;
-      if (op > table_op)
-        continue;
-
-      if ((insn & opcode->mask) != opcode->opcode
-          || (opcode->flags & dialect) == 0)
-        continue;
-
-      /* Make two passes over the operands.  First see if any of them
-         have extraction functions, and, if they do, make sure the
-         instruction is valid.  */
-      invalid = 0;
-      for (opindex = opcode->operands; *opindex != 0; opindex++)
-        {
-          operand = powerpc_operands + *opindex;
-          if (operand->extract)
-            (*operand->extract) (insn, &invalid);
-        }
-      if (invalid)
-        continue;
-
-      /* The instruction is valid.  */
-      (*info->fprintf_func) (info->stream, "%s", opcode->name);
-      if (opcode->operands[0] != 0)
-        (*info->fprintf_func) (info->stream, "\t");
-
-      /* Now extract and print the operands.  */
-      need_comma = 0;
-      need_paren = 0;
-      for (opindex = opcode->operands; *opindex != 0; opindex++)
-        {
-          long value;
-
-          operand = powerpc_operands + *opindex;
-
-          /* Operands that are marked FAKE are simply ignored.  We
-             already made sure that the extract function considered
-             the instruction to be valid.  */
-          if ((operand->flags & PPC_OPERAND_FAKE) != 0)
-            continue;
-
-          /* Extract the value from the instruction.  */
-          if (operand->extract)
-            value = (*operand->extract) (insn, (int *) NULL);
-          else
+          if ((operand->flags & I370_OPERAND_OPTIONAL) != 0) 
             {
-              value = (insn >> operand->shift) & ((1 << operand->bits) - 1);
-              if ((operand->flags & PPC_OPERAND_SIGNED) != 0
-                  && (value & (1 << (operand->bits - 1))) != 0)
-                value -= 1 << operand->bits;
-            }
-
-          /* If the operand is optional, and the value is zero, don't
-             print anything.  */
-          if ((operand->flags & PPC_OPERAND_OPTIONAL) != 0
-              && (operand->flags & PPC_OPERAND_NEXT) == 0
-              && value == 0)
-            continue;
-
-          if (need_comma)
+              if (value) 
+                (*info->fprintf_func) (info->stream, "(r%ld)", value);
+            } 
+          else
+          if ((operand->flags & I370_OPERAND_SBASE) != 0) 
             {
-              (*info->fprintf_func) (info->stream, ",");
-              need_comma = 0;
-            }
-
-          /* Print the operand as directed by the flags.  */
-          if ((operand->flags & PPC_OPERAND_GPR) != 0)
-            (*info->fprintf_func) (info->stream, "r%ld", value);
-          else if ((operand->flags & PPC_OPERAND_FPR) != 0)
-            (*info->fprintf_func) (info->stream, "f%ld", value);
-          else if ((operand->flags & PPC_OPERAND_RELATIVE) != 0)
-            (*info->print_address_func) (memaddr + value, info);
-          else if ((operand->flags & PPC_OPERAND_ABSOLUTE) != 0)
-            (*info->print_address_func) ((bfd_vma) value & 0xffffffff, info);
-          else if ((operand->flags & PPC_OPERAND_CR) == 0
-                   || (dialect & PPC_OPCODE_PPC) == 0)
-            (*info->fprintf_func) (info->stream, "%ld", value);
+              (*info->fprintf_func) (info->stream, "(r%ld)", value);
+            } 
           else
+          if ((operand->flags & I370_OPERAND_INDEX) != 0) 
             {
-              if (operand->bits == 3)
-                (*info->fprintf_func) (info->stream, "cr%d", value);
+              if (value) 
+                (*info->fprintf_func) (info->stream, "(r%ld,", value);
               else
-                {
-                  static const char *cbnames[4] = { "lt", "gt", "eq", "so" };
-                  int cr;
-                  int cc;
-
-                  cr = value >> 2;
-                  if (cr != 0)
-                    (*info->fprintf_func) (info->stream, "4*cr%d", cr);
-                  cc = value & 3;
-                  if (cc != 0)
-                    {
-                      if (cr != 0)
-                        (*info->fprintf_func) (info->stream, "+");
-                      (*info->fprintf_func) (info->stream, "%s", cbnames[cc]);
-                    }
-                }
-            }
-
-          if (need_paren)
-            {
-              (*info->fprintf_func) (info->stream, ")");
-              need_paren = 0;
-            }
-
-          if ((operand->flags & PPC_OPERAND_PARENS) == 0)
-            need_comma = 1;
+                (*info->fprintf_func) (info->stream, "(,");
+            } 
           else
+          if ((operand->flags & I370_OPERAND_LENGTH) != 0) 
             {
-              (*info->fprintf_func) (info->stream, "(");
-              need_paren = 1;
-            }
+              (*info->fprintf_func) (info->stream, "(%ld,", value);
+            } 
+          else
+          if ((operand->flags & I370_OPERAND_BASE) != 0)
+            (*info->fprintf_func) (info->stream, "r%ld)", value);
+          else
+          if ((operand->flags & I370_OPERAND_GPR) != 0)
+            (*info->fprintf_func) (info->stream, "r%ld,", value);
+          else
+          if ((operand->flags & I370_OPERAND_FPR) != 0)
+            (*info->fprintf_func) (info->stream, "f%ld,", value);
+          else
+          if ((operand->flags & I370_OPERAND_RELATIVE) != 0)
+            (*info->fprintf_func) (info->stream, "%ld", value);
+          else
+            (*info->fprintf_func) (info->stream, " %ld, ", value);
+
         }
 
-      /* We have found and printed an instruction; return.  */
-      return 4;
+      return opcode->len;
+
     }
 
+
   /* We could not find a match.  */
-  (*info->fprintf_func) (info->stream, ".long 0x%lx", insn);
+  (*info->fprintf_func) (info->stream, ".short 0x%x", insn.s[0]);
 
-  return 4;
+  return 2;
 }
-#endif
Index: i370-opc.c
===================================================================
RCS file: /home/linas/cvsroot/binutils/opcodes/i370-opc.c,v
retrieving revision 1.33
diff --unified=6 -r1.33 i370-opc.c
--- i370-opc.c	1999/09/03 20:56:08	1.33
+++ i370-opc.c	1999/09/03 22:46:59
@@ -1,11 +1,10 @@
-/* i370-opc.c -- 370/390 architecture opcode list
-   Copyright 1994, 1995, 1996, 1997, 1998 Free Software Foundation, Inc.
-   Written by Ian Lance Taylor, Cygnus Support
-   I370 table loosely based on the PPC table, 
-   Written by Linas Vepstas <linas@linas.org> in 1998, 1999
+/* i370-opc.c -- Instruction 370 (ESA/390) architecture opcode list
+   Copyright 1994-1999 Free Software Foundation, Inc.
+   PowerPC version written by Ian Lance Taylor, Cygnus Support
+   Rewritten for i370 ESA/390 support by Linas Vepstas <linas@linas.org> 1998, 1999
 
 This file is part of GDB, GAS, and the GNU binutils.
 
 GDB, GAS, and the GNU binutils are free software; you can redistribute
 them and/or modify them under the terms of the GNU General Public
 License as published by the Free Software Foundation; either version
@@ -111,13 +110,13 @@
 
   /* The X2 index field in an RX form instruction.  */
 #define RX_X2 (RX_R1 + 1)
 #define RX_X2_MASK (0xf << 16)
   { 4, 16, 0, 0, I370_OPERAND_GPR | I370_OPERAND_INDEX, "RX X2"},
 
-  /* The B2 base field in an RX or RS form instruction.  */
+  /* The B2 base field in an RX form instruction.  */
 #define RX_B2 (RX_X2 + 1)
 #define RX_B2_MASK (0xf << 12)
   { 4, 12, 0, 0, I370_OPERAND_GPR | I370_OPERAND_BASE, "RX B2"},
 
   /* The D2 displacement field in an RX form instruction.  */
 #define RX_D2 (RX_B2 + 1)
@@ -136,15 +135,20 @@
 
   /* The R3 register field in an RS form instruction.  */
 #define RS_R3 (RS_D2 + 1)
 #define RS_R3_MASK (0xf << 16)
   { 4, 16, 0, 0, I370_OPERAND_GPR, "RS R3" },
 
+  /* The B2 base field in an RS form instruction.  */
+#define RS_B2 (RS_R3 + 1)
+#define RS_B2_MASK (0xf << 12)
+  { 4, 12, 0, 0, I370_OPERAND_GPR | I370_OPERAND_BASE | I370_OPERAND_SBASE, "RS B2"},
+
   /* The optional B2 base field in an RS form instruction.  */
   /* Note that this field will almost always be absent */
-#define RS_B2_OPT (RS_R3 + 1)
+#define RS_B2_OPT (RS_B2 + 1)
 #define RS_B2_OPT_MASK (0xf << 12)
   { 4, 12, 0, 0, I370_OPERAND_GPR | I370_OPERAND_OPTIONAL, "RS B2 OPT"},
 
   /* The R1 register field in an RSI form instruction.  */
 #define RSI_R1 (RS_B2_OPT + 1)
 #define RSI_R1_MASK (0xf << 20)
@@ -185,23 +189,23 @@
 #define SI_D1_MASK (0xfff)
   { 12, 0, 0, 0, I370_OPERAND_RELATIVE, "SI D1" },
 
  /* The B2 base register field in an S form instruction.  */
 #define S_B2 (SI_D1 + 1)
 #define S_B2_MASK (0xf << 12)
-  { 4, 12, 0, 0, I370_OPERAND_GPR | I370_OPERAND_BASE, "S B2" },
+  { 4, 12, 0, 0, I370_OPERAND_GPR | I370_OPERAND_BASE | I370_OPERAND_SBASE, "S B2" },
 
   /* The D2 displacement field in an S form instruction.  */
 #define S_D2 (S_B2 + 1)
 #define S_D2_MASK (0xfff)
   { 12, 0, 0, 0, I370_OPERAND_RELATIVE, "S D2" },
 
   /* The L length field in an SS form instruction. */
 #define SS_L (S_D2 + 1)
 #define SS_L_MASK (0xffff<<16)
-  { 8, 16, 0, 0, I370_OPERAND_RELATIVE, "SS L" },
+  { 8, 16, 0, 0, I370_OPERAND_RELATIVE | I370_OPERAND_LENGTH, "SS L" },
 
  /* The B1 base register field in an SS form instruction.  */
 #define SS_B1 (SS_L + 1)
 #define SS_B1_MASK (0xf << 12)
   { 4, 12, 0, 0, I370_OPERAND_GPR, "SS B1" },
 
@@ -210,13 +214,13 @@
 #define SS_D1_MASK (0xfff)
   { 12, 0, 0, 0, I370_OPERAND_RELATIVE, "SS D1" },
 
  /* The B2 base register field in an SS form instruction.  */
 #define SS_B2 (SS_D1 + 1)
 #define SS_B2_MASK (0xf << 12)
-  { 4, 12, insert_ss_b2, extract_ss_b2, I370_OPERAND_GPR | I370_OPERAND_BASE, "SS B2" },
+  { 4, 12, insert_ss_b2, extract_ss_b2, I370_OPERAND_GPR | I370_OPERAND_BASE | I370_OPERAND_SBASE, "SS B2" },
 
   /* The D2 displacement field in an SS form instruction.  */
 #define SS_D2 (SS_B2 + 1)
 #define SS_D2_MASK (0xfff)
   { 12, 0, insert_ss_d2, extract_ss_d2, I370_OPERAND_RELATIVE, "SS D2" },
 
@@ -767,29 +771,29 @@
 { "madb",   6, RXFH(0xed,0,0,0,0), RXFL(0x1e,0), RXFH_MASK, RXFL_MASK, IBF, {RX_R1, RXF_R3, RX_D2, RX_X2, RX_B2}},
 { "maeb",   6, RXFH(0xed,0,0,0,0), RXFL(0x0e,0), RXFH_MASK, RXFL_MASK, IBF, {RX_R1, RXF_R3, RX_D2, RX_X2, RX_B2}},
 { "msdb",   6, RXFH(0xed,0,0,0,0), RXFL(0x1f,0), RXFH_MASK, RXFL_MASK, IBF, {RX_R1, RXF_R3, RX_D2, RX_X2, RX_B2}},
 { "mseb",   6, RXFH(0xed,0,0,0,0), RXFL(0x0f,0), RXFH_MASK, RXFL_MASK, IBF, {RX_R1, RXF_R3, RX_D2, RX_X2, RX_B2}},
 
 /* RS form instructions */
-{ "bxh",    4, RS(0x86,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RX_B2}},
-{ "bxle",   4, RS(0x87,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RX_B2}},
-{ "cds",    4, RS(0xbb,0,0,0,0), 0, RS_MASK, 0, IXA,  {RX_R1, RS_R3, RS_D2, RX_B2}},
-{ "clcle",  4, RS(0xa9,0,0,0,0), 0, RS_MASK, 0, ICM,  {RX_R1, RS_R3, RS_D2, RX_B2}},
-{ "clm",    4, RS(0xbd,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RX_B2}},
-{ "cs",     4, RS(0xba,0,0,0,0), 0, RS_MASK, 0, IXA,  {RX_R1, RS_R3, RS_D2, RX_B2}},
-{ "icm",    4, RS(0xbf,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RX_B2}},
-{ "lam",    4, RS(0x9a,0,0,0,0), 0, RS_MASK, 0, IESA, {RX_R1, RS_R3, RS_D2, RX_B2}},
-{ "lctl",   4, RS(0xb7,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RX_B2}},
-{ "lm",     4, RS(0x98,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RX_B2}},
-{ "mvcle",  4, RS(0xa8,0,0,0,0), 0, RS_MASK, 0, ICM,  {RX_R1, RS_R3, RS_D2, RX_B2}},
-{ "sigp",   4, RS(0xae,0,0,0,0), 0, RS_MASK, 0, IXA,  {RX_R1, RS_R3, RS_D2, RX_B2}},
-{ "stam",   4, RS(0x9b,0,0,0,0), 0, RS_MASK, 0, IESA, {RX_R1, RS_R3, RS_D2, RX_B2}},
-{ "stcm",   4, RS(0xbe,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RX_B2}},
-{ "stctl",  4, RS(0xb6,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RX_B2}},
-{ "stm",    4, RS(0x90,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RX_B2}},
-{ "trace",  4, RS(0x99,0,0,0,0), 0, RS_MASK, 0, IXA,  {RX_R1, RS_R3, RS_D2, RX_B2}},
+{ "bxh",    4, RS(0x86,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RS_B2}},
+{ "bxle",   4, RS(0x87,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RS_B2}},
+{ "cds",    4, RS(0xbb,0,0,0,0), 0, RS_MASK, 0, IXA,  {RX_R1, RS_R3, RS_D2, RS_B2}},
+{ "clcle",  4, RS(0xa9,0,0,0,0), 0, RS_MASK, 0, ICM,  {RX_R1, RS_R3, RS_D2, RS_B2}},
+{ "clm",    4, RS(0xbd,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RS_B2}},
+{ "cs",     4, RS(0xba,0,0,0,0), 0, RS_MASK, 0, IXA,  {RX_R1, RS_R3, RS_D2, RS_B2}},
+{ "icm",    4, RS(0xbf,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RS_B2}},
+{ "lam",    4, RS(0x9a,0,0,0,0), 0, RS_MASK, 0, IESA, {RX_R1, RS_R3, RS_D2, RS_B2}},
+{ "lctl",   4, RS(0xb7,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RS_B2}},
+{ "lm",     4, RS(0x98,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RS_B2}},
+{ "mvcle",  4, RS(0xa8,0,0,0,0), 0, RS_MASK, 0, ICM,  {RX_R1, RS_R3, RS_D2, RS_B2}},
+{ "sigp",   4, RS(0xae,0,0,0,0), 0, RS_MASK, 0, IXA,  {RX_R1, RS_R3, RS_D2, RS_B2}},
+{ "stam",   4, RS(0x9b,0,0,0,0), 0, RS_MASK, 0, IESA, {RX_R1, RS_R3, RS_D2, RS_B2}},
+{ "stcm",   4, RS(0xbe,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RS_B2}},
+{ "stctl",  4, RS(0xb6,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RS_B2}},
+{ "stm",    4, RS(0x90,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_R3, RS_D2, RS_B2}},
+{ "trace",  4, RS(0x99,0,0,0,0), 0, RS_MASK, 0, IXA,  {RX_R1, RS_R3, RS_D2, RS_B2}},
 
 /* RS form instructions with blank R3 and optional B2 (shift left/right) */
 { "sla",    4, RS(0x8b,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_D2, RS_B2_OPT}},
 { "slda",   4, RS(0x8f,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_D2, RS_B2_OPT}},
 { "sldl",   4, RS(0x8d,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_D2, RS_B2_OPT}},
 { "sll",    4, RS(0x89,0,0,0,0), 0, RS_MASK, 0, I370, {RX_R1, RS_D2, RS_B2_OPT}},
